<?php

/*
Plugin Name: mabna Payment Plugin for EDD
Plugin URI: http://www.softiran.org
Description: ماژول درگاه پرداخت آنلاین مبنا کارت
Version: 1.0
Author: softiran.org
Author URI: http://www.softiran.org
*/

function edd_add_gateway_mabna($gateways)
{
	global $edd_options;
	return array_merge($gateways, array(
				'mabna' => array(
					'admin_label'    => 'Mabna',
					'checkout_label' => $edd_options['mabna_gatename']
				)
			)
		);
}
add_filter('edd_payment_gateways', 'edd_add_gateway_mabna');

function edd_mabna_rial ($formatted, $currency, $price) {

	return $price . ' ریال';
}
add_filter( 'edd_rial_currency_filter_after', 'edd_mabna_rial', 10, 3 );

function edd_send_to_gateway_mabna($purchase_data)
{
	global $edd_options;
	$payment_data = array( 
			'price'        => $purchase_data['price'], 
			'date'         => $purchase_data['date'], 
			'user_email'   => $purchase_data['post_data']['edd_email'],
			'purchase_key' => $purchase_data['purchase_key'],
			'currency'     => $edd_options['currency'],
			'downloads'    => $purchase_data['downloads'],
			'cart_details' => $purchase_data['cart_details'],
			'user_info'    => $purchase_data['user_info'],
			'status'       => 'pending'
		);
		
	if ($payment = edd_insert_payment($payment_data))
	{
		$callBackUrl = add_query_arg('gateway', 'mabna', get_permalink($edd_options['success_page']));
		$return = add_query_arg('succ', 'Y', $callBackUrl);
		$price = (ceil($payment_data['price']));
		
		$redirectAddress = ($return);
		$amount = trim($price);
		$merchant = trim($edd_options['mabna_merchant']);
		$terminal = trim($edd_options['mabna_terminal']);
		$invoiceNumber = time();
		@session_start();
		$_SESSION['price'] = $price;
		$_SESSION['payment_id'] = $payment;
		$_SESSION['user_email'] = $payment_data['user_email'];
		
		if(!function_exists('timestamp_to_iso8601'))
		{
			include_once('nusoap.php');
		}
		
		$client = new nusoap_client("https://mabna.shaparak.ir/TokenService?wsdl", 'wsdl');
		$source = $amount.$invoiceNumber.$merchant.$redirectAddress.$terminal;
		$pat = dirname(__FILE__);
		$fp = fopen($pat . '/public.txt', "r");
		$pub_key = fread($fp, 8192);
		fclose($fp);
		if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
			$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

		if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
			$pub_key .= "\n-----END PUBLIC KEY-----";
	

		// Amount
		$key_resource=openssl_get_publickey($pub_key);

		openssl_public_encrypt($amount, $crypttext, $key_resource );

		 $Amount = base64_encode($crypttext);
		 // CRN
		 
		openssl_public_encrypt($invoiceNumber, $crypttext, $key_resource );
		$CRN = base64_encode($crypttext);

		// MID
		openssl_public_encrypt($merchant, $crypttext, $key_resource );
		$MID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($terminal, $crypttext, $key_resource );
		$TID = base64_encode($crypttext);

		// TID
		openssl_public_encrypt($redirectAddress, $crypttext, $key_resource );
		$referal = base64_encode($crypttext);

		$key = file_get_contents($pat . '/private.txt');

		if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
			$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

		if (strpos($key, '-----END PRIVATE KEY-----') === false)
			$key .= "\n-----END PRIVATE KEY-----";
		
		$priv_key = openssl_pkey_get_private($key);
		$signature = '';
		
		openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
		$inputArray = array("Token_param" => array("AMOUNT" => $Amount,
												   "CRN"    => $CRN,
												   "MID"    => $MID,
												   "REFERALADRESS" => $referal,
												   "SIGNATURE" => base64_encode($signature),
												   "TID" => $TID));
		$WSResult = $client->call("reservation", $inputArray);
		$signature = base64_decode($WSResult['return']['signature']);
		$ok = openssl_verify($WSResult["return"]["token"], $signature, $key_resource);
		openssl_free_key($key_resource);
		
		if ($ok == 1 && $WSResult['return']['result'] == 0) 
		{
			echo '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir" method="POST">
			<input type="hidden" id="TOKEN" name="TOKEN" value="'.$WSResult["return"]["token"].'">
		</form><script>
		function submitmabna() {
			document.getElementById("paymentUTLfrm").submit();
		}
	window.onload=submitmabna; </script>';

			exit;
		}else
		{
			echo $WSResult["return"]["token"];
		}
	}
	else
	{
		edd_send_back_to_checkout('?payment-mode='.$purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_mabna', 'edd_send_to_gateway_mabna');

function edd_gateway_mabna_verify()
{
	global $edd_options;
	@session_start();
	if (isset($_REQUEST['gateway']) && $_REQUEST['gateway'] == 'mabna' && isset($_REQUEST['succ']) && $_REQUEST['succ'] == 'Y')
	{
		
		if( isset($_POST['CRN']) && isset($_POST['TRN']) && isset($_POST['RESCODE']) && $_POST['RESCODE'] == '00' )
		{
			
			if(!function_exists('timestamp_to_iso8601'))
			{
				include_once('nusoap.php');
			}
			
			$merchant = trim($edd_options['mabna_merchant']);
			
			$client = new nusoap_client("https://mabna.shaparak.ir/TransactionReference/TransactionReference?wsdl", 'wsdl');
			$error = $client->getError();
			$pat = dirname(__FILE__);
			$fp = fopen($pat . '/public.txt', "r");
			$pub_key = fread($fp, 8192);
			fclose($fp);
			if (strpos($pub_key, '-----BEGIN PUBLIC KEY-----') === false)
				$pub_key = "-----BEGIN PUBLIC KEY-----\n" . $pub_key;

			if (strpos($pub_key, '-----END PUBLIC KEY-----') === false)
				$pub_key .= "\n-----END PUBLIC KEY-----";

			$key_resource = openssl_get_publickey($pub_key);

			openssl_public_encrypt($_POST["TRN"], $crypttext, $key_resource );
			$TRN = base64_encode($crypttext);

			// CRN
			openssl_public_encrypt($_POST["CRN"], $crypttext, $key_resource );
			$CRN = base64_encode($crypttext);

			// MID
			openssl_public_encrypt($merchant, $crypttext, $key_resource );
			$MID = base64_encode($crypttext);

			// Sign data
			$source = $merchant.$_POST["TRN"].$_POST["CRN"];
			
			$key = file_get_contents($pat . '/private.txt');

			if (strpos($key, '-----BEGIN PRIVATE KEY-----') === false)
				$key = "-----BEGIN PRIVATE KEY-----\n" . $key;

			if (strpos($key, '-----END PRIVATE KEY-----') === false)
				$key .= "\n-----END PRIVATE KEY-----";
		
			$priv_key = openssl_pkey_get_private($key);
			$signature = '';
			openssl_sign($source, $signature, $priv_key, OPENSSL_ALGO_SHA1);
			$inputArray = array("SaleConf_req" => array("MID"    => $MID,
														"CRN"    => $CRN,
														"TRN"    => $TRN,
														"SIGNATURE" => base64_encode($signature)));
			$WSResult = $client->call("sendConfirmation", $inputArray);
			$error = $client->getError();
			$signature = base64_decode($WSResult["return"]["SIGNATURE"]);
			$data      = $WSResult["return"]["RESCODE"].$WSResult["return"]["REPETETIVE"].$WSResult["return"]["AMOUNT"].$WSResult["return"]["DATE"].$WSResult["return"]["TIME"].$WSResult["return"]["TRN"].$WSResult["return"]["STAN"];

			$ok = openssl_verify($data, $signature, $key_resource);
			if ($ok == 1) 
			{
				 if (($WSResult['return']['RESCODE'] == '00') && ($WSResult['return']['successful'] == true)) 
				 {
					 if(floatval($WSResult["return"]["AMOUNT"])  == floatval($_SESSION['price']))
					{
						$RefNum = $WSResult["return"]["TRN"];
						edd_insert_payment_note($_SESSION['payment_id'], 'referenceId : '.$RefNum);
						edd_empty_cart();
						edd_update_payment_status($_SESSION['payment_id'], 'publish');
						wp_mail( get_bloginfo('admin_email'), 'پرداخت کامل در سایت', 'پرداخت کامل شد <br/> شماره پیگیری : '.$RefNum );
						wp_mail( $_SESSION['user_email'], 'پرداخت شما کامل شد', 'پرداخت کامل شد <br/> شماره پیگیری : '.$RefNum );
						$_SESSION['payment_id'] = 0;
						unset($_SESSION);
						edd_send_to_success_page();
					}else
					{
						$res = 'مبلغ واریز با مبلغ سفارش برابر نیست';
					}
				 }
			}
				
		}else
		{
			$res = 'برگشت نا موفق از درگاه';
		}
		$state = 'false';
		if(isset($_SESSION['payment_id']))
		{
			$state = edd_get_payment_status($_SESSION['payment_id'], true);
		}
		
		if(strtolower($state) != 'complete')
		{
			edd_insert_payment_note($_SESSION['payment_id'], 'Error : '.$res);
			edd_update_payment_status($_SESSION['payment_id'], 'failed');
			$failed_page = get_permalink($edd_options['failure_page']);
		}
		$_SESSION['payment_id'] = 0;
		unset($_SESSION);
		wp_redirect( $failed_page );
		exit;
			
		
	}
}


add_action('init', 'edd_gateway_mabna_verify');

function edd_gateway_mabna_setting($settings)
{
	return array_merge( $settings, array (
				array (
					'id'   => 'mabna_setting',
					'name' => 'mabna Setting',
					'desc' => 'mabna Setting',
					'type' => 'header'
				),
				array (
					'id'   => 'mabna_merchant',
					'name' => 'Merchant',
					'desc' => 'Merchant',
					'type' => 'text',
					'size' => 'regular'
				),
				array (
					'id'   => 'mabna_terminal',
					'name' => 'Terminal',
					'desc' => 'Terminal',
					'type' => 'text',
					'size' => 'regular'
				),
				array (
					'id'   => 'mabna_gatename',
					'name' => 'نام درگاه پرداخت',
					'desc' => 'نام بانک را وارد کنید',
					'type' => 'text',
					'size' => 'regular'
				)
			)
		);
}
add_filter('edd_settings_gateways', 'edd_gateway_mabna_setting');

function edd_mabna_cc_form_filter(){}
add_filter( 'edd_mabna_cc_form', 'edd_mabna_cc_form_filter' );


?>